﻿using System;
using System.Web.UI;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;
using System.Collections.ObjectModel;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            Map1.CurrentExtent = new RectangleShape(-123.22, 55.05, -76, 16.91);
            Map1.MapUnit = GeographyUnit.DecimalDegree;

            ShapeFileFeatureLayer shapeFileFeatureLayer = new ShapeFileFeatureLayer(MapPath("~/app_data/STATES.shp"));
            shapeFileFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(100, 212, 220, 184), GeoColor.FromArgb(255, 132, 132, 154), 1);
            shapeFileFeatureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay layerOverlay = new LayerOverlay();
            layerOverlay.Layers.Add(shapeFileFeatureLayer);
            Map1.CustomOverlays.Add(layerOverlay);

            LayerOverlay shapeOverlay = new LayerOverlay("ShapeOverlay", false, TileType.SingleTile);
            InMemoryFeatureLayer shapeLayer = new InMemoryFeatureLayer(new Collection<FeatureSourceColumn>() { new FeatureSourceColumn("ShapeType") }, new Collection<Feature>() { });
            shapeLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.CreateSimpleCircleStyle(GeoColor.FromArgb(180, 102, 255, 102), 10, GeoColor.StandardColors.DarkGreen, 1);
            shapeLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.StandardColors.Green, 4, true);
            shapeLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(180, 102, 255, 102), GeoColor.StandardColors.DarkGreen, 1);
            shapeLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = TextStyles.City1("ShapeType");
            shapeLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            shapeLayer.DrawingQuality = DrawingQuality.HighQuality;
            shapeOverlay.Layers.Add("shapeLayer", shapeLayer);
            Map1.CustomOverlays.Add(shapeOverlay);
        }
    }

    protected void ShapeSubmit(object sender, EventArgs e)
    {
        LayerOverlay shapeOverlay = Map1.CustomOverlays["ShapeOverlay"] as LayerOverlay;
        InMemoryFeatureLayer shapeLayer = shapeOverlay.Layers["shapeLayer"] as InMemoryFeatureLayer;
        string[] formStrings = Request.Form["iptShapeType"].Split(new Char[]{','}, StringSplitOptions.RemoveEmptyEntries);

        int index = 0;
        foreach (Feature feature in Map1.EditOverlay.Features)
        {
            feature.ColumnValues.Add("ShapeType", formStrings[index++]);
            shapeLayer.InternalFeatures.Add(feature);
        }
        Map1.EditOverlay.Features.Clear();
        shapeOverlay.Redraw();
    }
}
